<?php
function google_doc( $job , &$log ) {
    require_once("/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/library/google-api-php-client/src/Google/autoload.php");
    $fn = '/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/uploads/google_doc_error_log.txt'; 
    if($fp = fopen($fn, 'a')){
        fwrite($fp , "Google Doc Gearman Start-UTC Date".gmdate('Y-m-d g:i A')."\n");
    }
    $workload = unserialize($job->workload());
    $fileId = $workload['fileId'];
    $extfileId = $workload['extfileId'];
    $name   = $workload['name'];
    $includePath = $workload['includePath'];
    $companyId = $workload['companyId'];
    $copiedFile = new Google_Service_Drive_DriveFile();
    $copiedFile->setTitle($name);
    $extfileId = str_replace("spreadsheet:","",$extfileId);
    $extfileId = str_replace("document:","",$extfileId);
    $extfileId = str_replace("presentation:","",$extfileId);
    $clientEmail = '548230379440-5khps8irtupcebvfam5aghpm0ie426ga@developer.gserviceaccount.com';
    $privateKey = file_get_contents('/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/public/paperlessproposal-4e0703728295.p12');
    $scopes = array('https://www.googleapis.com/auth/drive');
    $userToImpersonate = 'do-not-reply@paperlessproposal.com';
    $credentials = new Google_Auth_AssertionCredentials(
        $clientEmail,
        $scopes,
        $privateKey,
        'notasecret',                                 // Default P12 password
        'http://oauth.net/grant_type/jwt/1.0/bearer', // Default grant type
        $userToImpersonate
    );
    $client = new Google_Client();
    $client->setAssertionCredentials($credentials);
    if($client->getAuth()->isAccessTokenExpired()) {
        $client->getAuth()->refreshTokenWithAssertion();
    }
    $service = new Google_Service_Drive($client);
    $quotaUser = substr(mt_rand(1000000000, 9999999999).time().rand().uniqid(), 1, 35);
    try {
        $fileGD = $service->files->copy($extfileId, $copiedFile, ['quotaUser' => $quotaUser]);
        $status = "Success";
        fwrite($fp , $fileId."-Copy Google Doc Success\n");
    }catch (Exception $e) {
        fwrite($fp , $fileId."-GOOGLE failed copyFile " . $e->getMessage()."\n\n\n");
        return NULL;
    }
    fwrite($fp , $fileId."-tests\n");
    if( $fileGD->id == $extfileId ){
        fwrite($fp , "file Ids are same\n\n");
        return null;
    }
    fwrite($fp , $fileId."-sdsds\n");
    $permission = new Google_Service_Drive_Permission();
    $permission->setRole( 'writer' );
    $permission->setType( 'anyone' );
    $permission->setWithLink(true);
    $permission->setValue( 'me' );
    $service->permissions->insert( $fileGD->getId(), $permission, ['quotaUser' => $quotaUser] );
    $filenameAndPath = $includePath . "/company_$companyId/$fileId.pdf";
    $fId = $fileGD->id;
    $fId = str_replace("spreadsheet:","",$fId);
    $fId = str_replace("document:","",$fId);
    $fId = str_replace("presentation:","",$fId);
    $file = $service->files->get($fId, ['quotaUser' => $quotaUser]);
    $pdfLink = $file->exportLinks["application/pdf"];
    $fpp = fopen($filenameAndPath, "wb");      
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 0);
    curl_setopt ($ch, CURLOPT_TIMEOUT, 500);
    curl_setopt($ch,CURLOPT_URL,$pdfLink);
    curl_setopt($ch, CURLOPT_FILE, $fpp);
    curl_exec($ch);
    curl_close($ch);
    fclose($fpp);
    $configDetails = parse_ini_file("/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/application/config.ini", true);
    $hostname    = $configDetails['production']['database.params.host']; 
    $username    = $configDetails['production']['database.params.username'];
    $password    = $configDetails['production']['database.params.password'];
    $dbname      = $configDetails['production']['database.params.dbname'];
    $mysqli = new mysqli($hostname, $username, $password, $dbname);
    if ($mysqli->connect_error) {
        fwrite( $fp,$fileId."-Unable to connect to MySQL \n" );
    }
    $stmt = $mysqli->prepare("UPDATE Files SET externalId=?, externalLink=?, processingStatus=?, processingMessage=? WHERE id=?");
    if ( false === $stmt ) {
        fwrite( $fp, $fileId."-Google Doc Gearman, Mysql Error - \n".$mysqli->error);
    }
    $empty = '';
    $stmt->bind_param('ssssd', $fileGD->id, $fileGD->alternateLink, $empty, $empty, $fileId);
    $stmt->execute();
    if ($stmt->errno) {
         fwrite( $fp, $fileId."-FAILURE!!! " . $stmt->error);
    }
    $stmt->close();
    $mysqli->close();
    fwrite( $fp, $fileId."-Status:Success \n\n");
    fclose($fp);
    $job->sendComplete($status);
    return "Success";
}
?>