<?php
function html_to_pdf($job, &$log) {
	$workload = unserialize($job->workload());
	$error_log_file = $workload['error_log_file'];
	$proposalFileId = $workload['proposalFileId'];  
    $fp = fopen($error_log_file, 'a');
	fwrite($fp, "proposalFileId=".$proposalFileId." Worker Start Html to Pdf \n");
    fwrite($fp, "proposalFileId=".$proposalFileId."Job_Workload=".$job->workload()."\n");
   	$command = $workload['command'];
	$configDetails = $workload['configDetails'];
	$application_env = $workload['application_env'];
	$fileNameOut = $workload['fileNameOut'];
    exec( $command, $output, $return_var );
    fwrite($fp, "proposalFileId=".$proposalFileId."\n WKHTMLTOPDF Response \n ".print_r($output, true)." \n Return variable \n ".$return_var ."\n");
	if (file_exists($fileNameOut)){
		fwrite( $fp, "proposalFileId=".$proposalFileId." File Exist \n" );
    	$configDetails = parse_ini_file( $configDetails , true);
	    $hostname    = $configDetails[$application_env]['database.params.host']; 
	    $username    = $configDetails[$application_env]['database.params.username'];
	    $password    = $configDetails[$application_env]['database.params.password'];
	    $dbname      = $configDetails[$application_env]['database.params.dbname'];
	    $mysqli = new mysqli($hostname, $username, $password, $dbname);
	    if ($mysqli->connect_error) {
	        fwrite( $fp, "proposalFileId=".$proposalFileId." Unable to connect to MySQL \n" );
	    }else{
	    	fwrite( $fp, "proposalFileId=".$proposalFileId." Connected to MySQL \n" );
	    }
	    $stmt = $mysqli->prepare("UPDATE ProposalFiles SET processingStatus=?, processingMessage=? WHERE id=?");
	    if ( false === $stmt ) {
	        fwrite( $fp, "proposalFileId=".$proposalFileId." Mysql Error - \n".$mysqli->error."\n");
	    }
	    $empty = null;
	    $stmt->bind_param('ssd', $empty, $empty, $proposalFileId);
	    $stmt->execute();
	    if ($stmt->errno) {
	         fwrite( $fp, "proposalFileId=".$proposalFileId." FAILURE!!! " . $stmt->error."\n");
	    }
	    $stmt->close();
	    $mysqli->close();
	    fwrite( $fp, "proposalFileId=".$proposalFileId." Status:Success \n\n");
	}else{
		fwrite( $fp, "proposalFileId=".$proposalFileId."File Not Exist \n" );
	}
	fclose($fp);
    $job->sendComplete($status);
    return "Success";
}
?>

