<?php
function merge_pptx($job, &$log) {
	
	$msg = 'Gearman start merge pptx';
	
	require_once("/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/library/merlin/classes/mergeables/pptx_mergeables.php");
    $workload = unserialize($job->workload());

    $firstFile = $workload['firstFile']; 
    //$file_array = $workload['file_array'];
    $finalDoc = $workload['finalDoc'];
    $fileId = $workload['fileId'];
    $proposalFiles = $workload['proposalFiles'];
    $proposalFilesPrint=$workload['proposalFilesPrint'];
    $files_input_dir=$workload['files_input_dir']; 
    $error=array();
    
		if(count($proposalFiles) > 0 && !empty($proposalFilesPrint)) {
    			
    		foreach($proposalFiles as $proposalFile) {
    			if(isset($proposalFile->id) && in_array($proposalFile->id, $proposalFilesPrint)) {
    				if(isset($proposalFile->fileId) &&	$proposalFile->type == 'ppt') {
    					$ppFile = $files_input_dir.$proposalFile->fileId.'.'.$proposalFile->type;
    					$ppTxFile = $files_input_dir.$proposalFile->fileId.'.'.'pptx';
    					//echo $ppTxFile; die;
    					if(!file_exists("$ppFile")) {
    						$error[] = $proposalFile->name;
    						unset($files[$key]);
    					}
    					if (file_exists("$ppFile") && !file_exists("$ppTxFile")) {
    						chdir($files_input_dir);
    						putenv('HOME=/mnt/vol/var/www');
    						$command = 'echo $HOME &&  /usr/bin/libreoffice --headless --invisible -env:UserInstallation=file:///tmp/libreofficeppttopptx --convert-to pptx '.$proposalFile->fileId.'.ppt';
    						exec($command, $output, $result_var);
    					}
    				}
    			}
    		}
    			
    	} else if (count($proposalFiles) > 0) {
    			
    		foreach($proposalFiles as $proposalFile) {
    			if(isset($proposalFile->id)) {
    				if(isset($proposalFile->fileId) &&	$proposalFile->type == 'ppt') {
    					$ppFile = $files_input_dir.$proposalFile->fileId.'.'.$proposalFile->type;
    					$ppTxFile = $files_input_dir.$proposalFile->fileId.'.'.'pptx';
    					if(!file_exists("$ppFile")) {
    						$error[] = $proposalFile->name;
    						unset($files[$key]);
    					}
    					if (file_exists("$ppFile") && !file_exists("$ppTxFile")) {
    						chdir($files_input_dir);
    						putenv('HOME=/mnt/vol/var/www');
    						$command = 'echo $HOME &&  /usr/bin/libreoffice --headless --invisible -env:UserInstallation=file:///tmp/libreofficeppttopptx --convert-to pptx '.$proposalFile->fileId.'.ppt';
    						exec($command, $output, $result_var);
    					}
    				}
    			}
    		}
    			
    	}
    
    	$file_array = array();
    	$proposalFilesPrint = array();
    	if(empty($error)) {
    		$file_info=array();
    		foreach($proposalFiles as $key => $proposalFile) {
    			if(isset($proposalFile->fileId) && ($proposalFile->type == 'ppt' || $proposalFile->type == 'pptx')) {
    				$file_info[$key]['id'] 	= $proposalFile->id;
    				$file_info[$key]['file_name']	= $proposalFile->fileId.".pptx";
    			}
    		}

    		$allPPTfiles = array();
    			
    		foreach($file_info as $pptfiles) {
    			if(in_array($pptfiles['id'] ,$proposalFilesPrint)) {
    				$file_array[] = $pptfiles['file_name'];
    			} else {
    				$allPPTfiles[] = $pptfiles['file_name'];
    			}
    		}
    		
    		if(empty($file_array)) {
    			$file_array = $allPPTfiles;
    		}
    		
    		@unlink($finalDoc);
    		
			$main_obj = new PptxMergeables($finalDoc);
			for($i=0;$i<count($file_array);$i++) {
				chdir($files_input_dir);
				$obj[$i]=new PptxMergeables($files_input_dir.$file_array[$i]);
				$main_obj->append($obj[$i]);
			}
			
			
    
    	}
    // DB connection details
    $configDetails 	= parse_ini_file("/mnt/vol/var/www/securityupdate.clientpoint.net/proposal/application/config.ini",true);
    // DB connection details
    //$configDetails 	= parse_ini_file("/mnt/vol/var/www/dematic/proposal/application/config.ini",true);
    $hostname 	= $configDetails['production']['database.params.host'];
    $username 	= $configDetails['production']['database.params.username'];
    $password 	= $configDetails['production']['database.params.password'];
    $dbname		= $configDetails['production']['database.params.dbname'];
    	
    //connection to the database
    $dbhandle = mysql_connect($hostname, $username, $password, $dbname);

    if($dbhandle){
    	$msg .= "Connected to MySQL\n";
    }else{
    	$msg .= "Unable to connect to MySQL\n";
    }
    //select a database to work with
    $selected = mysql_select_db($dbname,$dbhandle);
    if($selected){
    	$msg .= "Connected to DB\n";
    }else{
    	$msg .= "Could not select db\n";
    }

    // update data in mysql database
    echo $sql="UPDATE Files SET processingStatus = NULL WHERE id = '$fileId'";
    
    $result=mysql_query($sql);
    
    if($result){
    	$status= 'success';
    	$msg .= "Records were updated successfully.\n";

    } else {
    	$status= 'failed';
    	$msg .= "\n ERROR: Could not able to execute $sql. ";
    }
    
    /*
    $fp = fopen('/mnt/vol/var/www/dematicnewserver.paperlessproposal.com/proposal/public/data.txt1', 'a');
    //$fp = fopen('/mnt/vol/var/www/stage.paperlessproposal.com/htdocs/data.txt', 'a');
    fwrite($fp, $msg);
    fclose($fp);
	*/
    
    $job->sendComplete($status);
    return 'Success';
    
    

}
?>

